<?php

/**
 * rvsp_formato_factura_det actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage rvsp_formato_factura_det
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class rvsp_formato_factura_detActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'RVSP_FORMATO_FACTURA_DET',
        'INTERCEROS',
        'RVSP_TIPO_SERVICIO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'INTERCEROS,LEFT' =>
        array(
            'id_mae_ter' => 'RVSP_FORMATO_FACTURA_DET'
        ),
        'RVSP_TIPO_SERVICIO,LEFT' =>
        array(
            'id_tipo_servicio' => 'RVSP_FORMATO_FACTURA_DET'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'RVSP_FORMATO_FACTURA_DET' =>
        array(
            'id_formato_factura_det' => 'id_formato_factura_det',
            'id_formato_factura' => 'id_formato_factura',
            'id_mae_ter' => 'id_mae_ter',
            'valor' => 'valor',
            'subtotal_total_factura' => 'subtotal_total_factura',
            'valor_intereses' => 'valor_intereses',
            'iva_total_factura' => 'iva_total_factura',
            'id_tipo_servicio' => 'id_tipo_servicio',
            'usuario_log' => 'usuario_log',
            'fecha_log' => 'fecha_log',
            'consumo_inicial' => 'consumo_inicial',
            'consumo_final' => 'consumo_final',
            'cantidad_consumo' => 'cantidad_consumo'
        ),
        'RVSP_TIPO_SERVICIO' =>
        array(
            'descripcion' => 'tipo_servicio'
        ),
        'INTERCEROS' =>
        array(
            'razon_soc' => 'nombre_proveedor',
            'num_doc' => 'documento_proveedor'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * EJEMPLO: 'titular' => array('NULL' => array('titular')),
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'RVSP_FORMATO_FACTURA_DET' => array(
            'id_formato_factura,a' => array('!=' => array(-1)),
            'id_formato_factura,b' => array('=' => array('id_formato_factura')),
            'id_tipo_servicio' => array('=' => array('id_tipo_servicio')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
            /* 'RVC_CONTRATISTA_V' =>
              array(
              'num_doc' => array('LIKE' => array('input', '%')),
              'razon_social' => array('LIKEALLPLUS' => array('input', '%'))
              ) */
    ); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'id_tipo_servicio'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_formato_factura_det'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_formato_factura_det'); //llave primaria
    protected $field_names = array('id_formato_factura', 'id_mae_ter', 'valor', 'subtotal_total_factura',
        'iva_total_factura', 'valor_intereses', 'id_tipo_servicio',
        'usuario_log', 'fecha_log', 'consumo_inicial', 'consumo_final', 'cantidad_consumo'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'RVSP_FORMATO_FACTURA_DET'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_formato_factura_det'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a validateAdd");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_formato_factura = $request['id_formato_factura'];
        $valor = $request['valor'];

        if ($valor <= 0) {


            $errors['mensaje'] = "Ingrese un valor mayor a cero.";
            $errors['servicio'] = "rvsp_formato_factura_det";
            $logger->info("Ingresar un valor mayor a cero.");
        }

        /*
         *  Generar errores en $errors
         */
        //Valida que el valor de la novedad no supere el valor de aporte colciencias mas otros desembolsos
        //sentencia sql
        $sql = <<<EOD
select
cont.id_formato_factura,
cont.valor_total as valor_total,
sum(novdes.valor) as valor_cont

from rvsp_formato_factura cont

left join rvsp_formato_factura_det novdes
on novdes.id_formato_factura = cont.id_formato_factura

where
cont.id_formato_factura = $id_formato_factura

group by
cont.id_formato_factura,
cont.valor_total 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0) {

            $valor_total = $records[0]['valor_total'];
            $valor_cont = $records[0]['valor_cont'];

            if (($valor_cont + $valor) > $valor_total) {

                $valor_text = number_format($valor);
                $valor_total_text = number_format($valor_total);

                $errors['mensaje'] = "El valor($valor_text) supera el valor de total de la factura($valor_total_text), verificar.";
                $errors['servicio'] = "rvsp_formato_factura_det";
                $logger->info("El valor($valor_text) supera el valor de total de la factura($valor_total_text), verificar.");
            }
        }

        $id_mae_ter = $request['id_mae_ter'];
        //Validar que sea un tercero - 20201105::LAVILA
        $sql = <<<EOD
SELECT
    *
FROM interceros
where
id_mae_ter = $id_mae_ter
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) == 0) {

            //sino lo busca como num_doc
            $sql = <<<EOD
SELECT
    *
FROM interceros
where
num_doc = '$id_mae_ter'
EOD;
            //ejecuta el sql
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) == 0) {
                $errors['mensaje'] = "El numero($id_mae_ter) ingresado no pertenece a un proveedor, verificar.";
                $errors['servicio'] = "rvsp_formato_factura";
                $logger->info("El numero ingresado no pertenece a un proveedor, verificar.");
            } else {
                $request['id_mae_ter'] = $records[0]['id_mae_ter'];
            }
        }
        
        // Validar que no exista ya un cronograma con factura para el tipo de servicio centro operacion mes y año
        $id_tipo_servicio = $request['id_tipo_servicio'];
        $sql= <<<EOD
select tab0.id_cen_op,tab0.id_formato_factura, extract(month from tab0.fecha_emision) as mes,
extract(year from tab0.fecha_emision) as anho,tab0.id_mae_ter as empresa_fact
from rvsp_formato_factura tab0
where tab0.id_formato_factura = $id_formato_factura
EOD;
        $records = CN_TABLE::executeSQL($sql);
        $id_cen_op = $records[0]['id_cen_op'];
        $id_meses = $records[0]['mes'];
        $id_anhos = $records[0]['anho'];
        $sql = <<<EOD
select *
from rvsp_cronograma_servicio
where id_cen_op = $id_cen_op and id_meses = $id_meses 
and id_anhos=$id_anhos 
and id_tipo_servicio in ($id_tipo_servicio)
and id_formato_factura_det is not null                                
EOD;
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0) {
                $errors['mensaje'] = "Ya se encuentra registrado factura en el cronograma para el servicio en la vigecnia de la factura.";
                $errors['servicio'] = "rvsp_formato_factura";
                $logger->info("ya se encuentra registrado factura en el cronograma para el tipo de servicio  $id_tipo_serviciotipo en la vigencia.");
        }
        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;
        $logger = sfContext::getInstance()->getLogger();

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_formato_factura = $request['id_formato_factura'];
        $id_formato_factura_det = $request['id_formato_factura_det'];
        $valor = $request['valor'];

        if ($valor <= 0) {
            $errors['mensaje'] = "Ingrese un valor mayor a cero.";
            $errors['servicio'] = "rvsp_formato_factura_det";
            $logger->info("Ingresar un valor mayor a cero.");
        }

        $sql = <<<EOD
select
*
from rvsp_formato_factura_det novdes
where
novdes.id_formato_factura=$id_formato_factura
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        if (count($records) == 1) {

            /*
             *  Generar errores en $errors
             */
            //Valida que el valor de la novedad no supere el valor de aporte colciencias mas otros desembolsos
            //sentencia sql
            $sql = <<<EOD
select
cont.id_formato_factura,
cont.valor_total as valor_total,
sum(novdes.valor) as valor_cont
                    
from rvsp_formato_factura cont
                    
left join rvsp_formato_factura_det novdes
on novdes.id_formato_factura = cont.id_formato_factura
where
cont.id_formato_factura = $id_formato_factura
group by
cont.id_formato_factura,
cont.valor_total 
EOD;
            //ejecuta el sql
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {

                $valor_total = $records[0]['valor_total'];
                $valor_cont = $records[0]['valor_cont'];

                if ($valor > $valor_total) {

                    $valor_text = number_format($valor);
                    $valor_total_text = number_format($valor_total);

                    $errors['mensaje'] = "El valor($valor_text) supera el valor de total de la factura($valor_total_text), verificar.";
                    $errors['servicio'] = "rvsp_formato_factura_det";
                    $logger->info("El valor($valor_text) supera el valor de total de la factura($valor_total_text), verificar.");
                }
            }
        } elseif (count($records) > 1) {

            /*
             *  Generar errores en $errors
             */
            //Valida que el valor de la novedad no supere el valor de aporte colciencias mas otros desembolsos
            //sentencia sql
            $sql = <<<EOD
select
cont.id_formato_factura,
cont.valor_total as valor_total,
sum(novdes.valor) as valor_cont

from rvsp_formato_factura cont

left join rvsp_formato_factura_det novdes
on novdes.id_formato_factura = cont.id_formato_factura

where
cont.id_formato_factura = $id_formato_factura and
novdes.id_formato_factura_det!=$id_formato_factura_det

group by
cont.id_formato_factura,
cont.valor_total 
EOD;
            //ejecuta el sql
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {

                $valor_total = $records[0]['valor_total'];
                $valor_cont = $records[0]['valor_cont'];

                if (($valor_cont + $valor) > $valor_total) {

                    $valor_text = number_format($valor);
                    $valor_total_text = number_format($valor_total);

                    $errors['mensaje'] = "El valor($valor_text) supera el valor de total de la factura($valor_total_text), verificar.";
                    $errors['servicio'] = "rvsp_formato_factura_det";
                    $logger->info("El valor($valor_text) supera el valor de total de la factura($valor_total_text), verificar.");
                }
            }
        }


        $id_mae_ter = $request['id_mae_ter'];
        //Validar que sea un tercero - 20201105::LAVILA
        $sql = <<<EOD
SELECT
    *
FROM interceros
where
id_mae_ter = $id_mae_ter
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) == 0) {

            //sino lo busca como num_doc
            $sql = <<<EOD
SELECT
    *
FROM interceros
where
num_doc = '$id_mae_ter'
EOD;
            //ejecuta el sql
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) == 0) {
                $errors['mensaje'] = "El numero($id_mae_ter) ingresado no pertenece a un proveedor, verificar.";
                $errors['servicio'] = "rvsp_formato_factura";
                $logger->info("El numero ingresado no pertenece a un proveedor, verificar.");
            } else {
                $request['id_mae_ter'] = $records[0]['id_mae_ter'];
            }
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['username'];
            $request['fecha_log'] = CN_TABLE::fechaSistema();
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
